/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.asoftware.letsmeet.entity;

import java.io.Serializable;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;

/**
 *
 * @author aubrech
 */
@Entity
@Table(name = "assignment")
@NamedQueries({
    @NamedQuery(name = "Assignment.findAll", query = "SELECT a FROM Assignment a"),
    @NamedQuery(name = "Assignment.listSelections", query = "SELECT a FROM Assignment a WHERE a.asgEventId = :asgEventId"),
    @NamedQuery(name = "Assignment.findByAsgId", query = "SELECT a FROM Assignment a WHERE a.asgId = :asgId"),
    @NamedQuery(name = "Assignment.findByAsgComment", query = "SELECT a FROM Assignment a WHERE a.asgComment = :asgComment")
})
public class Assignment implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "asg_id", nullable = false)
    @GeneratedValue(strategy=GenerationType.IDENTITY)
    private Integer asgId;
    @Column(name = "asg_comment", length = 255)
    private String asgComment;
    @JoinColumn(name = "asg_event_id", referencedColumnName = "event_id", nullable = false)
    @ManyToOne(optional = false)
    private Event asgEventId;
    @JoinColumn(name = "asg_option", referencedColumnName = "option_id")
    @ManyToOne
    private EventOption asgOption;
    @JoinColumn(name = "asg_participant", referencedColumnName = "participant_id", nullable = false)
    @ManyToOne(optional = false)
    private Participant asgParticipant;

    public Assignment() {
    }

    public Assignment(Integer asgId) {
        this.asgId = asgId;
    }

    public Integer getAsgId() {
        return asgId;
    }

    public void setAsgId(Integer asgId) {
        this.asgId = asgId;
    }

    public String getAsgComment() {
        return asgComment;
    }

    public void setAsgComment(String asgComment) {
        this.asgComment = asgComment;
    }

    public Event getAsgEventId() {
        return asgEventId;
    }

    public void setAsgEventId(Event asgEventId) {
        this.asgEventId = asgEventId;
    }

    public EventOption getAsgOption() {
        return asgOption;
    }

    public void setAsgOption(EventOption asgOption) {
        this.asgOption = asgOption;
    }

    public Participant getAsgParticipant() {
        return asgParticipant;
    }

    public void setAsgParticipant(Participant asgParticipant) {
        this.asgParticipant = asgParticipant;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (asgId != null ? asgId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Assignment)) {
            return false;
        }
        Assignment other = (Assignment) object;
        if ((this.asgId == null && other.asgId != null) || (this.asgId != null && !this.asgId.equals(other.asgId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "cz.asoftware.letsmeet.Assignment[asgId=" + asgId + "]";
    }

}
