/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.asoftware.letsmeet.entity;

import java.io.Serializable;
import java.util.Collection;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;

/**
 *
 * @author aubrech
 */
@Entity
@Table(name = "event")
@NamedQueries({@NamedQuery(name = "Event.findAll", query = "SELECT e FROM Event e"), @NamedQuery(name = "Event.findByEventId", query = "SELECT e FROM Event e WHERE e.eventId = :eventId"), @NamedQuery(name = "Event.findByEventName", query = "SELECT e FROM Event e WHERE e.eventName = :eventName")})
public class Event implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "event_id", nullable = false)
    @GeneratedValue(strategy=GenerationType.IDENTITY)
    private Integer eventId;
    @Column(name = "event_name", length = 100)
    private String eventName;
    @Column(name = "event_comment")
    private String eventComment;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "asgEventId")
    private Collection<Assignment> assignmentCollection;
    @OneToMany(mappedBy = "optionEventId")
    private Collection<EventOption> eventOptionCollection;

    public Event() {
    }

    public Event(Integer eventId) {
        this.eventId = eventId;
    }

    public Integer getEventId() {
        return eventId;
    }

    public void setEventId(Integer eventId) {
        this.eventId = eventId;
    }

    public String getEventName() {
        return eventName;
    }

    public void setEventName(String eventName) {
        this.eventName = eventName;
    }

    public Collection<Assignment> getAssignmentCollection() {
        return assignmentCollection;
    }

    public void setAssignmentCollection(Collection<Assignment> assignmentCollection) {
        this.assignmentCollection = assignmentCollection;
    }

    public Collection<EventOption> getEventOptionCollection() {
        return eventOptionCollection;
    }

    public void setEventOptionCollection(Collection<EventOption> eventOptionCollection) {
        this.eventOptionCollection = eventOptionCollection;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (eventId != null ? eventId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Event)) {
            return false;
        }
        Event other = (Event) object;
        if ((this.eventId == null && other.eventId != null) || (this.eventId != null && !this.eventId.equals(other.eventId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "cz.asoftware.letsmeet.Event[eventId=" + eventId + "]";
    }

    /**
     * @return the eventComment
     */
    public String getEventComment() {
        return eventComment;
    }

    /**
     * @param eventComment the eventComment to set
     */
    public void setEventComment(String eventComment) {
        this.eventComment = eventComment;
    }

}
