/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.asoftware.letsmeet.entity;

import java.io.Serializable;
import java.util.Collection;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;

/**
 *
 * @author aubrech
 */
@Entity
@Table(name = "event_option")
@NamedQueries({
    @NamedQuery(name = "EventOption.findAll", query = "SELECT e FROM EventOption e"),
    @NamedQuery(name = "EventOption.findByOptionId", query = "SELECT e FROM EventOption e WHERE e.optionId = :optionId"),
    @NamedQuery(name = "EventOption.findByOptionName", query = "SELECT e FROM EventOption e WHERE e.optionName = :optionName")
})
public class EventOption implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "option_id", nullable = false)
    @GeneratedValue(strategy=GenerationType.IDENTITY)
    private Integer optionId;
    @Basic(optional = false)
    @Column(name = "option_name", nullable = false, length = 100)
    private String optionName;
    @Basic(optional = false)
    @Column(name = "option_order", nullable = false)
    private Integer optionOrder;
    @OneToMany(mappedBy = "asgOption")
    private Collection<Assignment> assignmentCollection;
    @JoinColumn(name = "option_event_id", referencedColumnName = "event_id")
    @ManyToOne
    private Event optionEventId;

    public EventOption() {
    }

    public EventOption(Integer optionId) {
        this.optionId = optionId;
    }

    public EventOption(Integer optionId, String optionName) {
        this.optionId = optionId;
        this.optionName = optionName;
    }

    public Integer getOptionId() {
        return optionId;
    }

    public void setOptionId(Integer optionId) {
        this.optionId = optionId;
    }

    public String getOptionName() {
        return optionName;
    }

    public void setOptionName(String optionName) {
        this.optionName = optionName;
    }

    public Collection<Assignment> getAssignmentCollection() {
        return assignmentCollection;
    }

    public void setAssignmentCollection(Collection<Assignment> assignmentCollection) {
        this.assignmentCollection = assignmentCollection;
    }

    public Event getOptionEventId() {
        return optionEventId;
    }

    public void setOptionEventId(Event optionEventId) {
        this.optionEventId = optionEventId;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (optionId != null ? optionId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof EventOption)) {
            return false;
        }
        EventOption other = (EventOption) object;
        if ((this.optionId == null && other.optionId != null) || (this.optionId != null && !this.optionId.equals(other.optionId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "cz.asoftware.letsmeet.EventOption[optionId=" + optionId + "]";
    }

    /**
     * @return the optionOrder
     */
    public Integer getOptionOrder() {
        return optionOrder;
    }

    /**
     * @param optionOrder the optionOrder to set
     */
    public void setOptionOrder(Integer optionOrder) {
        this.optionOrder = optionOrder;
    }

}
