/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.asoftware.letsmeet.entity;

import java.io.Serializable;
import java.util.Collection;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;

/**
 *
 * @author aubrech
 */
@Entity
@Table(name = "participant")
@NamedQueries({
    @NamedQuery(name = "Participant.findAll", query = "SELECT p FROM Participant p order by p.participantName"),
    @NamedQuery(name = "Participant.findByParticipantId", query = "SELECT p FROM Participant p WHERE p.participantId = :participantId"),
    @NamedQuery(name = "Participant.findByParticipantName", query = "SELECT p FROM Participant p WHERE p.participantName = :participantName")
})
public class Participant implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "participant_id", nullable = false)
    @GeneratedValue(strategy=GenerationType.IDENTITY)
    private Integer participantId;
    @Basic(optional = false)
    @Column(name = "participant_name", nullable = false, length = 100)
    private String participantName;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "asgParticipant")
    private Collection<Assignment> assignmentCollection;

    public Participant() {
    }

    public Participant(Integer participantId) {
        this.participantId = participantId;
    }

    public Participant(Integer participantId, String participantName) {
        this.participantId = participantId;
        this.participantName = participantName;
    }

    public Integer getParticipantId() {
        return participantId;
    }

    public void setParticipantId(Integer participantId) {
        this.participantId = participantId;
    }

    public String getParticipantName() {
        return participantName;
    }

    public void setParticipantName(String participantName) {
        this.participantName = participantName;
    }

    public Collection<Assignment> getAssignmentCollection() {
        return assignmentCollection;
    }

    public void setAssignmentCollection(Collection<Assignment> assignmentCollection) {
        this.assignmentCollection = assignmentCollection;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (participantId != null ? participantId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Participant)) {
            return false;
        }
        Participant other = (Participant) object;
        if ((this.participantId == null && other.participantId != null) || (this.participantId != null && !this.participantId.equals(other.participantId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "cz.asoftware.letsmeet.Participant[participantId=" + participantId + "]";
    }

}
