/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.asoftware.letsmeet.backing;

import cz.asoftware.letsmeet.beans.MeetingBeanLocal;
import cz.asoftware.letsmeet.entity.Assignment;
import cz.asoftware.letsmeet.entity.Event;
import cz.asoftware.letsmeet.entity.EventOption;
import cz.asoftware.letsmeet.entity.Participant;
import cz.asoftware.letsmeet.model.ParticipantSelections;
import java.util.ArrayList;
import java.util.List;
import javax.ejb.EJB;
import javax.el.ValueExpression;
import javax.faces.component.html.HtmlColumn;
import javax.faces.component.html.HtmlDataTable;
import javax.faces.component.html.HtmlOutputText;
import javax.faces.component.html.HtmlPanelGroup;
import javax.faces.context.FacesContext;
import javax.faces.model.DataModel;
import javax.faces.model.ListDataModel;

/**
 *
 * @author aubrech
 */
public class Events {
    @EJB
    MeetingBeanLocal meetingBean;
    private ListDataModel allParticipants;

    private Participant selectedParticipant;
    private ParticipantSelections selectedParticipantSelections;

    DataModel allEvents;
    private Event selectedEvent = null;

    private HtmlDataTable eventDetailTable;
    private HtmlPanelGroup eventDetailTablePanel;
    private List<EventOption> options;
    private List<String> optionsStrings;

    private List<ParticipantSelections> selections;

    public Events() {
    }


    public DataModel getAllParticipants() {
        allParticipants = new ListDataModel(meetingBean.listAllParticipants());
        return allParticipants;
    }

    public DataModel getAllEvents() {
        if(allEvents==null) {
            allEvents = new ListDataModel(meetingBean.listAllEvents());
        }
        return allEvents;
    }

    public void clearEvents() {
        allEvents = null;
    }

    public void clearUsers() {
        allParticipants = null;
    }

    public String refreshList() {
        clearEvents();
        clearUsers();
        return null;
    }

    public String goToEvent() {
        setSelectedEvent((Event) allEvents.getRowData());
        options = meetingBean.listOptionsPerEvent(selectedEvent);
        optionsStrings = new ArrayList<String>();
        for(EventOption o : options) {
            optionsStrings.add(o.getOptionId().toString());
        }
        eventDetailTablePanel = null;
        refreshParticipantSelections();
        if (selectedParticipantSelections == null) {
            selectedParticipantSelections = new ParticipantSelections();
            selectedParticipantSelections.setParticipant(selectedParticipant);
            for (EventOption o : options) {
                Assignment asgn = new Assignment();
                asgn.setAsgOption(o);
                asgn.setAsgEventId(selectedEvent);
                asgn.setAsgParticipant(selectedParticipant);
                selectedParticipantSelections.addAssignment(asgn);
            }

        }
        newOption = "";

        return "viewEvent";
    }

    /**
     * @return the selectedEvent
     */
    public Event getSelectedEvent() {
        return selectedEvent;
    }

    /**
     * @param selectedEvent the selectedEvent to set
     */
    public void setSelectedEvent(Event selectedEvent) {
        this.selectedEvent = selectedEvent;
    }

    /**
     * @return the eventDetailTablePanel
     */
    public HtmlPanelGroup getEventDetailTablePanel() {
        if(eventDetailTablePanel==null) {
            eventDetailTablePanel = new HtmlPanelGroup();
            eventDetailTable = new HtmlDataTable();
            eventDetailTable.setBorder(1);
            eventDetailTable.setValueExpression("value", createValueExpr(
                    "#{events.participantSelections}",
                    List.class));
            eventDetailTable.setVar("item");

            HtmlColumn nameCol = new HtmlColumn();
            eventDetailTable.getChildren().add(nameCol);
            HtmlOutputText nameHead = new HtmlOutputText();
            nameHead.setValue("Name");
            nameCol.setHeader(nameHead);

            HtmlOutputText nameVal = new HtmlOutputText();
            nameVal.setValueExpression("value", createValueExpr("#{item.participant.participantName}", String.class));
            nameCol.getChildren().add(nameVal);

            for(EventOption o : options) {
                HtmlColumn valCol = new HtmlColumn();
                eventDetailTable.getChildren().add(valCol);
                HtmlOutputText valHead = new HtmlOutputText();
                valHead.setValue(o.getOptionName());
                valCol.setHeader(valHead);

                HtmlOutputText val = new HtmlOutputText();
                val.setValueExpression("value", createValueExpr("#{item.comments['"+o.getOptionId()+"']}", String.class));
                valCol.getChildren().add(val);
            }

            eventDetailTablePanel.getChildren().add(eventDetailTable);
        }
        return eventDetailTablePanel;
    }

    /**
     * save the participants' comments
     * @return always null to return back
     */
    public String saveAssign() {
        meetingBean.saveSelections(selectedParticipantSelections);
        refreshParticipantSelections();
        // return back to the same form, just refresh the 
        return null;
    }

    public List<ParticipantSelections> getParticipantSelections() {
        return selections;
    }

    private ValueExpression createValueExpr(String expr, Class<?> valueType) {
        FacesContext cont = FacesContext.getCurrentInstance();
        return cont.getApplication().getExpressionFactory().createValueExpression(
                cont.getELContext(), expr, valueType);
    }

    /**
     * @param eventDetailTablePanel the eventDetailTablePanel to set
     */
    public void setEventDetailTablePanel(HtmlPanelGroup eventDetailTablePanel) {
        this.eventDetailTablePanel = eventDetailTablePanel;
    }

    /**
     * @return the selectedParticipant
     */
    public Participant getSelectedParticipant() {
        return selectedParticipant;
    }

    /**
     * @param selectedParticipant the selectedParticipant to set
     */
    public void setSelectedParticipant(Participant selectedParticipant) {
        this.selectedParticipant = selectedParticipant;
    }

    /**
     * setup participant and stay at the same form
     * @return always null
     */
    public String selectParticipant() {
        selectedParticipant = (Participant)allParticipants.getRowData();
        return null;
    }

    /**
     * @return the selectedParticipantSelections
     */
    public ParticipantSelections getSelectedParticipantSelections() {
        return selectedParticipantSelections;
    }

    /**
     * @param selectedParticipantSelections the selectedParticipantSelections to set
     */
    public void setSelectedParticipantSelections(ParticipantSelections selectedParticipantSelections) {
        this.selectedParticipantSelections = selectedParticipantSelections;
    }

    /**
     * @return the options
     */
    public List<String> getOptionsStrings() {
        return optionsStrings;
    }

    private void refreshParticipantSelections() {
        selections = new ArrayList<ParticipantSelections>(meetingBean.listParticipantSelections(selectedEvent));
        selectedParticipantSelections = null;
        for (ParticipantSelections ps : selections) {
            if (ps.getParticipant().getParticipantId().equals(selectedParticipant.getParticipantId())) {
                selectedParticipantSelections = ps;
            }
        }
    }

    /////////////////////// new option for an event
    private String newOption;

    /**
     * @return the newOption
     */
    public String getNewOption() {
        return newOption;
    }

    /**
     * @param newOption the newOption to set
     */
    public void setNewOption(String newOption) {
        this.newOption = newOption;
    }

    public String addOption() {
        EventOption option = new EventOption();
        option.setOptionName(newOption);
        option.setOptionEventId(selectedEvent);
        int maxOrder = -1;
        for(EventOption o : selectedEvent.getEventOptionCollection()) {
            maxOrder = Math.max(maxOrder, o.getOptionOrder());
        }
        option.setOptionOrder(maxOrder+1);
        meetingBean.persist(option);
        return null;
    }
}
